// VGA and Sprite routines   3-27-98
// 3-28-98 Fixed Binary shifting bug, added ClearScreen
// 4-02-98 Added VGA check(if not Vga,return a 0) And Verticle Retrace wait
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <mem.h>
#define SCREEN_SIZE         (word)(64000)
#define VERTICAL_RETRACE
typedef unsigned char  byte;
typedef unsigned short word;
byte *VGA;
//byte *VGA=(byte *)0xA0000000L;        /* this points to video memory. */
byte *VGA2=(byte *)0xA0000000L;
word *my_clock=(word *)0x0000046C;    /* this points to 18.2hz system clock.*/
// Set_Mode -=- Sets the video mode.
// 0x13 = VGA 256 color mode, 0x03 = 80x25 text mode
void set_mode(byte mode)
{
  union REGS regs;
  regs.h.ah = 0x00;
  regs.h.al = mode;
  int86(0x10, &regs, &regs);
}
//ScreenCopy -=- copies screen into buffer
void ScreenCopy()
{
memcpy (VGA,VGA2,64000);
}
//Print strings in color in 13h
void Printf(char *String, int Row, int Column, int Color)
{
   while (*String != '\0') {
       {
	union REGS Regs;
	Regs.h.bh = 0;
	Regs.h.dh = Row;
	Regs.h.dl = Column;
	Regs.h.ah = 2;
	int86(0x10, &Regs, &Regs);
      }
       Column++;
      {
	union REGS Regs;
	Regs.h.bh = 0;
	Regs.h.al = *String++;
	Regs.h.bl = Color;
	Regs.x.cx = 1;
	Regs.h.ah = 9;
	int86(0x10, &Regs, &Regs);
      }
   }
}
//SetBuffer -=- sets up buffer
void SetBuffer()
{
  if ((VGA = (byte *) malloc(65000)) == NULL)
  {
    printf("Not enough memory for double buffer.\n");
    exit(1);
  }
  memset(VGA,0,64000);
}
//ClearScreen -=- Clears the screen(SLOW!!)
void ClearScreen()
{
unsigned int screenbig;
int j;
screenbig=64000;
for (j=0;j<screenbig;j++)
{VGA[j]=0;}
}
// PlotPixel -=- Plots pixel by directly writing to video memory.
void PlotPixel(int x,int y,byte color)
{VGA[y*320+x]=color;}
// Draws sprite on screen
void SpritePut(int sx3,int sy3,int *spr1)
{
int spritex,spritey,sx2,sy2;
int XLen,YLen;
int j;
XLen=spr1[0];YLen=spr1[1];
j=2;
for (spritey=0; spritey< YLen; spritey++)
  {for(spritex=0; spritex< XLen; spritex++)
//   {VGA[(spritey + sy3)*320+(spritex + sx3)]=spr1[j];
// Uses binary shifting
   {VGA[(((spritey + sy3)<<8) + ((spritey+sy3)<<6)) + (spritex + sx3)]=spr1[j];
   j++;}}
}

// Draws transparent sprites
void SpriteDraw(int sx3,int sy3,int *spr1)
{
int spritex,spritey,sx2,sy2;
int XLen,YLen;
int j;
XLen=spr1[0];YLen=spr1[1];
j=2;
for (spritey=0; spritey< YLen; spritey++)
  {for(spritex=0; spritex< XLen; spritex++)
   {if(spr1[j] > 0)
    {
//    VGA[(spritey + sy3)*320+(spritex + sx3)]=spr1[j];
      VGA[(((spritey + sy3)<<8) + ((spritey+sy3)<<6)) + (spritex + sx3)]=spr1[j];
    }
   j++;}}
}

// Gets image from video memory
// Example: SpriteGet(16,16,20,32,grass);
// 16x16 sprite  20,30 where to start the get on screen
// grass is the name of the sprite
void SpriteGet(int XLen, int YLen, int sx3,int sy3,int *spr1)
{
int spritex,spritey,sx2,sy2;
int j;
spr1[0]=XLen;spr1[1]=YLen;
j=2;
for (spritey=0; spritey< YLen; spritey++)
  {for(spritex=0; spritex< XLen; spritex++)
//    {spr1[j]=VGA[(spritey + sy3)*320+(spritex + sx3)];
    {spr1[j]=VGA[ (((spritey + sy3)<<8) + ((spritey + sy3)<<6)) + (spritex + sx3)];
    j++;}}
}

void SpriteGet2(int XLen, int YLen, int sx3,int sy3,int *spr1)
{
int spritex,spritey,sx2,sy2;
int j;
spr1[0]=XLen;spr1[1]=YLen;
spritex=0;
for (spritey=0; spritey< YLen; spritey++)
  {
   memcpy(spr1+2,VGA+(((spritey + sy3)<<8) + ((spritey + sy3)<<6)) + (spritex + sx3),XLen);
   spr1+=XLen;
   }}
void SpritePut2(int sx3,int sy3,int *spr1)
{
int spritex,spritey,sx2,sy2,XLen,YLen;
XLen=spr1[0];YLen=spr1[1];spritex=0;
for (spritey=0; spritey< YLen; spritey++)
 {memcpy (VGA+(((spritey + sy3)<<8) + ((spritey + sy3)<<6)) + (spritex + sx3),spr1+2,XLen);
 spr1+=XLen;}}

void SpriteGet3(int XLen, int YLen, int sx3,int sy3,int *spr1)
{
int spritex,spritey,sx2,sy2;
int j;
spr1[0]=XLen;spr1[1]=YLen;
spritex=0;
for (spritey=0; spritey< YLen; spritey++)
  {
   memcpy(spr1+2,VGA2+(((spritey + sy3)<<8) + ((spritey + sy3)<<6)) + (spritex + sx3),XLen);
   spr1+=XLen;
   }}
void WaitVR()
// Waits for Verticle Retrace
{
    while ((inp(0x03da) & 0x08));
    while (!(inp(0x03da) & 0x08));
    memcpy (VGA2,VGA,64000);
}

// wait Wait for a specified number of clock ticks (18hz).
void wait()
{
  word start;
  start=*my_clock;
  while (*my_clock-start<1)
 {}
//    {*my_clock=*my_clock;}/* this line is for some compilers that would otherwise ignore this loop */
}
void DetectVGA(int VGAYES)
{
	union REGS regs;
	/* try a BIOS call only the vga understands */
	regs.x.bx = 0xFFFF;regs.x.ax = 0x101A;
	int86(0x10, &regs, &regs);
	/* if the card didn't understand, its not vga */
	if (regs.x.bx == 0xFFFF) VGAYES = 0;
	// returns 1 if it is VGA
	else VGAYES = 1;
}

